=== debian/changelog ===
rocrand (6.4.3-1) unstable; urgency=medium

  * Upload to unstable
  * Update my email address and copyright
  * Drop inactive maintainers from uploaders
  * Update symbol tracking with optional symbols

  [ Igor Luppi ]
  * d/rules: use GPU_TARGETS instead of deprecated AMDGPU_TARGETS

 -- Cordell Bloor <cgmb@debian.org>  Tue, 28 Oct 2025 21:31:30 -0600

rocrand (6.4.3-1~exp1) experimental; urgency=medium

  * New upstream version 6.4.3
  * Update d/gbp.conf to follow DEP-14
  * run-tests: Conditionalize artifacts on AUTOPKGTEST_ARTIFACTS
  * Use rocm-target-arch to select and document build GPU arch

 -- Christian Kastner <ckk@debian.org>  Sat, 09 Aug 2025 08:13:03 +0200
