=== debian/rules ===
#!/usr/bin/make -f
export CXX=hipcc
export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=-lto
export DEB_CXXFLAGS_MAINT_PREPEND = -gz
export VERBOSE=1
#export AMD_LOG_LEVEL=4

# filter incompatible options from affecting device code
CXXFLAGS := $(subst -fstack-protector-strong,-Xarch_host -fstack-protector-strong,$(CXXFLAGS))
CXXFLAGS := $(subst -fcf-protection,-Xarch_host -fcf-protection,$(CXXFLAGS))

CMAKE_FLAGS = \
	-DCMAKE_BUILD_TYPE=Release \
	-DCMAKE_SKIP_INSTALL_RPATH=ON \
	-DROCM_SYMLINK_LIBS=OFF \
	-DGPU_TARGETS="$(shell rocm-target-arch --sep ';')" \
	-DBUILD_FILE_REORG_BACKWARD_COMPATIBILITY=OFF \
	-DENABLE_INLINE_ASM=1
ifeq (,$(filter nocheck,$(DEB_BUILD_PROFILES)))
CMAKE_FLAGS += -DBUILD_TEST=ON
endif

%:
	dh $@

override_dh_auto_configure-arch:
	dh_auto_configure -- $(CMAKE_FLAGS)

override_dh_auto_test-arch:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	set -e \
	; if [ -r /dev/kfd ] \
	; then dh_auto_test --no-parallel -- \
	; else echo "W: /dev/kfd unreadable: no available AMD GPU." \
	;      echo "W: tests skipped." \
	; fi
endif

execute_before_dh_install-arch:
	:

override_dh_auto_configure-indep:
	:

# python3-rocm-docs can only build offline with the help of some envvars
override_dh_auto_build-indep:
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	http_proxy='127.0.0.1:9' \
	https_proxy='127.0.0.1:9' \
	ROCM_DOCS_REMOTE_DETAILS=http://localhost,local \
	latest_version= \
	release_candidate= \
	sphinx-build -v -b html docs rocrand-html
endif

override_dh_auto_test-indep:
	:

override_dh_auto_install-indep:
	:

# dwz doesn't fully support DWARF-5 yet, see #1016936
override_dh_dwz:
	:

override_dh_gencontrol:
	dh_gencontrol -- -Vrocm:GPU-Architecture="$(shell rocm-target-arch)"
