=== debian/tests/control ===
Test-Command: rocm-test-launcher /usr/libexec/rocm/librocrand1-tests/run-tests
Features: test-name=librocrand1-tests
Depends: pkg-rocm-tools, librocrand1-tests
Restrictions: skippable, allow-stderr
Architecture: amd64 arm64 ppc64el
