=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%rocrand-$1.tar.gz%" \
https://github.com/ROCm/rocRAND/tags \
(?:.*?/)?rocm-v?(\d[\d.]*)\.tar\.gz debian
